from Crypto.Cipher import AES
from Crypto.Util.Padding import pad, unpad
from pwn import xor
from tqdm import tqdm
import requests, multiprocessing, string


base_url = 'https://aes.cryptohack.org/'

def check_admin(ciphertext: bytes, iv: bytes):
    route = '/flipping_cookie/check_admin/{}/{}/'.format(ciphertext.hex(), iv.hex())
    response = requests.get(base_url + route)
    return response.json()

def get_cookie():
    route = '/flipping_cookie/get_cookie'
    response = requests.get(base_url + route)
    return bytes.fromhex(response.json()['cookie'])

cookie = get_cookie()
iv, data = cookie[:16], cookie[16:]
new_iv = xor(iv, b'admin=False;expi', b'admin=True; expi')
flag = check_admin(data, new_iv)['flag']
print(flag)